#include <iostream>
#include <vector>
#include <sstream>
#include "histogram.h"
#include "svg.h"

using namespace std;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
};

Input input_data(istream& in, bool prompt)
{
    size_t number_count;
    if (prompt) {
        cerr << "Number count: ";
    }
    in >> number_count;

    Input input;
    input.numbers.resize(number_count);

    if (prompt) {
        cerr << "Numbers: ";
    }
    for (size_t i = 0; i < number_count; i++) {
        in >> input.numbers[i];
    }

    if (prompt) {
        cerr << "Enter bin count: ";
    }
    in >> input.bin_count;

    return input;
}

int main(int argc, char* argv[]) {
    auto in = input_data(cin, true);
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_svg(bins);
    return 0;
}
